// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition (C++)" by Clifford A. Shaffer.
// Source code Copyright (C) 2007-2011 by Clifford A. Shaffer.

// General tree node ADT
template <typename Elem> class GTNode {
public:
  Elem value();                    // Return node's value
  bool isLeaf();                   // True if node is a leaf
  GTNode* parent();                // Return parent
  GTNode* leftmostChild();         // Return first child
  GTNode* rightSibling();          // Return right sibling
  void setValue(Elem&);            // Set node's value
  void insertFirst(GTNode<Elem>*); // Insert first child
  void insertNext(GTNode<Elem>*);  // Insert next sibling
  void removeFirst();              // Remove first child
  void removeNext();               // Remove right sibling
};

// General tree ADT
template <typename Elem> class GenTree {
public:
  void clear();            // Send all nodes to free store
  GTNode<Elem>* root();    // Return the root of the tree
  // Combine two subtrees
  void newroot(Elem&, GTNode<Elem>*, GTNode<Elem>*);
  void print();            // Print a tree
};
