// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition (C++)" by Clifford A. Shaffer.
// Source code Copyright (C) 2007-2011 by Clifford A. Shaffer.

// HuffTree is a template of two parameters: the element
//  type being coded and a comparator for two such elements.
template <typename Elem>
class HuffTree {
private:
  HuffNode<Elem>* Root;         // Tree root
public:
  HuffTree(Elem& val, int freq) // Leaf constructor
    { Root = new LeafNode<Elem>(freq, val); }
  // Internal node constructor
  HuffTree(HuffTree<Elem>* l, HuffTree<Elem>* r)
    { Root = new IntlNode<Elem>(l->root(), r->root()); }
  ~HuffTree() {}                // Destructor
  HuffNode<Elem>* root() { return Root; } // Get root
  int weight() { return Root->weight(); } // Root weight
};
