// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition (C++)" by Clifford A. Shaffer.
// Source code Copyright (C) 2007-2011 by Clifford A. Shaffer.

// Stack abtract class
template <typename Elem> class Stack {
private:
  void operator =(const Stack&) {}     // Protect assignment
  Stack(const Stack&) {}         // Protect copy constructor

public:
  Stack() {}                       // Default constructor
  virtual ~Stack() {}              // Base destructor

  // Reinitialize the stack.  The user is responsible for
  // reclaiming the storage used by the stack elements.
  virtual void clear() = 0;

  // Push an element onto the top of the stack.
  virtual void push(const Elem&) = 0;

  // Remove and return the element at the top of the stack.
  virtual Elem pop() = 0;

  // Return a copy of the top element.
  virtual const Elem& topValue() const = 0;

  // Return the number of elements in the stack.
  virtual int length() const = 0;
};
